<?php
/*****************************************************************************/
/* MoveThread.php                                                            */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$movethreadphpver = 'YaBB SE 1.5.1';

function MoveThread()
{
	global $username, $moderators, $settings, $txt, $currentboard, $color, $cgi, $threadid, $ubbcjspath, $db_prefix, $sc, $yytitle;

	if (!in_array($username,$moderators) && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator')
		fatal_error($txt[134]);

	$yytitle = $txt[132];
	$boardlist = '';

	$request = mysql_query("
		SELECT b.ID_BOARD, b.name, c.name AS catName
		FROM {$db_prefix}boards AS b, {$db_prefix}categories AS c
		WHERE (b.ID_BOARD != $currentboard && b.ID_CAT=c.ID_CAT)
		ORDER BY c.catOrder, b.boardOrder") or database_error(__FILE__, __LINE__);

	while ($row = mysql_fetch_assoc($request))
		$boardlist .= "<option value=\"$row[ID_BOARD]\">$row[catName] - $row[name]</option>\n";
	mysql_free_result($request);

	template_header();

	print '
		<script language="JavaScript1.2" src="' . $ubbcjspath . '" type="text/javascript"></script>
		<table border="0" width="400" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="4" align="center">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[132] . '</b></font></td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valgin="middle" align="center">
					<font size="2">
						<form action="' . $cgi . ';action=movethread2;threadid=' . $threadid . '" method="post" onsubmit="submitonce(this);"><br />
							<table border="0"><tr><td>
								<b>' . $txt[133] . ':</b><select name="toboard">' . $boardlist . '</select><br /> <br />
								<input type="hidden" name="postRedirect" value="0" /><input type="checkbox" name="postRedirect" value="1" checked="checked" /> ' . $txt['moveTopic1'] . '<br /> <br />
								' . $txt['yse57'] . '<br />
								<textarea rows="3" cols="35" name="reason"></textarea><br /> <br />
								<input type="submit" value="' . $txt[132] . '" />
							</td></tr></table>
							<input type="hidden" name="sc" value="' . $sc . '" />
						</form>
					</font>
				</td>
			</tr>
		</table>';

	footer();
	obExit();
}

function MoveThread2()
{
	global $username, $moderators, $settings, $txt, $currentboard, $threadid, $scripturl, $toboard, $yySetLocation;
	global $db_prefix, $reason, $ID_MEMBER, $realemail, $REMOTE_ADDR, $board, $doLimitOne, $postRedirect, $language, $chklngfile, $chklngfile2;

	checkSession();

	if (!in_array($username,$moderators) && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator')
		fatal_error($txt[134]);

	if (!is_numeric($threadid) || !is_numeric($board))
		fatal_error($txt[337]);

	$request = mysql_query("
		SELECT t.numReplies,m.subject
		FROM {$db_prefix}topics as t,{$db_prefix}messages as m
		WHERE (t.ID_TOPIC=$threadid AND t.ID_FIRST_MSG=m.ID_MSG AND t.ID_BOARD=$board)") or database_error(__FILE__, __LINE__);

	if (mysql_num_rows($request) == 0)
		fatal_error($txt[472]);

	$A_moved = mysql_fetch_assoc($request);
	mysql_free_result($request);
	$threadposts = $A_moved['numReplies'] + 1;
	
	$request = mysql_query("UPDATE {$db_prefix}topics SET ID_BOARD=$toboard WHERE ID_TOPIC=$threadid") or database_error(__FILE__, __LINE__);

	$request = mysql_query("UPDATE {$db_prefix}boards SET numPosts=((numPosts-$threadposts)+1) WHERE ID_BOARD = $currentboard") or database_error(__FILE__, __LINE__);

	$request = mysql_query("UPDATE {$db_prefix}boards SET numTopics=numTopics+1, numPosts=numPosts+$threadposts WHERE ID_BOARD = $toboard") or database_error(__FILE__, __LINE__);
	
	// create a link to this in the old board
	if ($postRedirect == 1)
	{
		$curlanguage = ($chklngfile == Null ? $language : $chklngfile2);
		if ($curlanguage != $language)
			include($language);

		$request = mysql_query("
			INSERT INTO {$db_prefix}topics (ID_BOARD,ID_MEMBER_STARTED,ID_MEMBER_UPDATED,locked,numReplies,numViews,notifies)
			VALUES ('$board','$ID_MEMBER','$ID_MEMBER',1,0,0,'')") or database_error(__FILE__, __LINE__);

		$remnantTopic = mysql_insert_id();
		$remnantSubject = addcslashes("$txt[yse56]: $A_moved[subject]",'"\'');
		$reason .= "\n\n[iurl]$scripturl?board=$toboard;action=display;threadid={$threadid}[/iurl]";
		if (get_magic_quotes_gpc() == 0)
			$reason = mysql_escape_string($reason);

		$request = mysql_query("
			INSERT INTO {$db_prefix}messages (ID_MEMBER,ID_TOPIC,subject,body,posterName,posterTime,posterEmail,posterIP,icon)
			VALUES ('$ID_MEMBER','$remnantTopic','$remnantSubject','$reason','$username','".time()."','$realemail','$REMOTE_ADDR','moved')") or database_error(__FILE__, __LINE__);

		$remnantMsg = mysql_insert_id();
		$request = mysql_query("
			UPDATE {$db_prefix}topics
			SET ID_LAST_MSG='$remnantMsg',ID_FIRST_MSG='$remnantMsg'
			WHERE ID_TOPIC='$remnantTopic'
			$doLimitOne") or database_error(__FILE__, __LINE__);
			
		// Increase post count
		$request = mysql_query("
			SELECT count FROM {$db_prefix}boards
			WHERE ID_BOARD = '$board'") or database_error(__FILE__, __LINE__);

		$pcount = mysql_fetch_array($request);
		$pcounter = $pcount['count'];

		if ($pcounter != 1)
		{
			++$settings[6];
			$request = mysql_query("
				UPDATE {$db_prefix}members
				SET posts = posts + 1
				WHERE ID_MEMBER = $ID_MEMBER
				$doLimitOne") or database_error(__FILE__, __LINE__);
		}
	}
	else
		$request = mysql_query ("UPDATE {$db_prefix}boards SET numPosts=numPosts-1, numTopics=numTopics-1 WHERE ID_BOARD=$currentboard") or database_error(__FILE__, __LINE__);

	updateStats('topic');
	updateStats('message');
	updateLastMessage($currentboard);
	updateLastMessage($toboard);

	mysql_query("UPDATE {$db_prefix}calendar SET id_board='$toboard' WHERE id_topic='$threadid'") or database_error(__FILE__, __LINE__);

	$yySetLocation = "$scripturl?board=$toboard;action=display;threadid=$threadid;start=0";
	redirectexit();
}

?>